Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90	(revision 3938)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90	(revision 3938)
@@ -0,0 +1,306 @@
+MODULE bdyice_lim
+   !!======================================================================
+   !!                       ***  MODULE  bdyice_lim  ***
+   !! Unstructured Open Boundary Cond. :  Open boundary conditions for sea-ice (LIM2 and LIM3)
+   !!======================================================================
+   !!  History :  3.3  !  2010-09 (D. Storkey)  Original code
+   !!             3.4  !  2011    (D. Storkey)  rewrite in preparation for OBC-BDY merge
+   !!              -   !  2012-01 (C. Rousset)  add lim3 and remove useless jk loop 
+   !!----------------------------------------------------------------------
+#if defined   key_bdy   &&  ( defined key_lim2 || defined key_lim3 )
+   !!----------------------------------------------------------------------
+   !!   'key_bdy'            and                 Unstructured Open Boundary Conditions
+   !!   'key_lim2'                                                 LIM-2 sea ice model
+   !!   'key_lim3'                                                 LIM-3 sea ice model
+   !!----------------------------------------------------------------------
+   !!   bdy_ice_lim        : Application of open boundaries to ice
+   !!   bdy_ice_frs        : Application of Flow Relaxation Scheme
+   !!----------------------------------------------------------------------
+   USE timing          ! Timing
+   USE phycst          ! physical constant
+   USE eosbn2          ! equation of state
+   USE oce             ! ocean dynamics and tracers variables
+#if defined key_lim2
+   USE par_ice_2
+   USE ice_2           ! LIM_2 ice variables
+#elif defined key_lim3
+   USE par_ice
+   USE ice             ! LIM_3 ice variables
+#endif 
+   USE par_oce         ! ocean parameters
+   USE dom_oce         ! ocean space and time domain variables 
+   USE dom_ice          ! sea-ice domain
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE bdy_oce         ! ocean open boundary conditions
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE in_out_manager  ! write to numout file
+   USE lib_mpp         ! distributed memory computing
+   USE lib_fortran     ! to use key_nosignedzero
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   bdy_ice_lim    ! routine called in sbcmod
+
+   REAL(wp) ::   epsi20 = 1.e-20_wp  ! module constants
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id: bdyice.F90 2715 2011-03-30 15:58:35Z rblod $
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE bdy_ice_lim( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  SUBROUTINE bdy_ice_lim  ***
+      !!
+      !! ** Purpose : - Apply open boundary conditions for ice (LIM2 and LIM3)
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) :: kt     ! Main time step counter
+      !!
+      INTEGER               :: ib_bdy ! Loop index
+      DO ib_bdy=1, nb_bdy
+
+         SELECT CASE( nn_ice_lim(ib_bdy) )
+         CASE(jp_none)
+            CYCLE
+         CASE(jp_frs)
+            CALL bdy_ice_frs( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
+         CASE DEFAULT
+            CALL ctl_stop( 'bdy_ice_lim : unrecognised option for open boundaries for ice fields' )
+         END SELECT
+      ENDDO
+
+   END SUBROUTINE bdy_ice_lim
+
+   SUBROUTINE bdy_ice_frs( idx, dta, kt )
+      !!------------------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_ice_frs  ***
+      !!                    
+      !! ** Purpose : Apply the Flow Relaxation Scheme for sea-ice fields in the case 
+      !!              of unstructured open boundaries.
+      !! 
+      !! Reference : Engedahl H., 1995: Use of the flow relaxation scheme in a three-
+      !!             dimensional baroclinic ocean model with realistic topography. Tellus, 365-382.
+      !!------------------------------------------------------------------------------
+      TYPE(OBC_INDEX), INTENT(in) ::   idx  ! OBC indices
+      TYPE(OBC_DATA),  INTENT(in) ::   dta  ! OBC external data
+      INTEGER, INTENT( in )       ::   kt   ! main time-step counter
+      !!
+      INTEGER  ::   jb, jk, jgrd, jl   ! dummy loop indices
+      INTEGER  ::   ji, jj             ! local scalar
+      REAL(wp) ::   zwgt, zwgt1        ! local scalar
+      REAL(wp) ::   zinda, ztmelts
+      REAL(wp), DIMENSION(2,2) :: zindaa
+      !!------------------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 ) CALL timing_start('bdy_ice_frs')
+      !
+      !IF( kt /= nit000 ) THEN
+      jgrd = 1      ! Everything is at T-points here
+      !
+#if defined key_lim2
+      DO jb = 1, idx%nblen(jgrd)
+         ji    = idx%nbi(jb,jgrd)
+         jj    = idx%nbj(jb,jgrd)
+         zwgt  = idx%nbw(jb,jgrd)
+         zwgt1 = 1.e0 - idx%nbw(jb,jgrd)
+         frld (ji,jj) = ( frld (ji,jj) * zwgt1 + dta%frld (jb) * zwgt ) * tmask(ji,jj,1)     ! Leads fraction 
+         hicif(ji,jj) = ( hicif(ji,jj) * zwgt1 + dta%hicif(jb) * zwgt ) * tmask(ji,jj,1)     ! Ice depth 
+         hsnif(ji,jj) = ( hsnif(ji,jj) * zwgt1 + dta%hsnif(jb) * zwgt ) * tmask(ji,jj,1)     ! Snow depth
+
+         zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - frld(ji,jj) ) ) ! 0 if no ice
+         !------------------------------
+         ! Sea ice surface temperature
+         !------------------------------
+         sist(ji,jj)   = zinda * 270.0 + ( 1.0 - zinda ) * tfu(ji,jj)
+         !-----------------------------------------------
+         ! Ice/snow temperatures and energy stored in brines 
+         !-----------------------------------------------
+         !!! A CONTINUER !!!
+            zindhe = MAX( 0.e0, SIGN( 1.e0, fcor(1,jj) ) )              ! = 0 for SH, =1 for NH
+ 
+               ! Recover in situ values.
+               zindb         = MAX( rzero, SIGN( rone, zs0a(ji,jj) - epsi06 ) )
+               zacrith       = 1.0 - ( zindhe * acrit(1) + ( 1.0 - zindhe ) * acrit(2) )
+               zs0a (ji,jj)  = zindb * MIN( zs0a(ji,jj), zacrith )
+               hsnif(ji,jj)  = zindb * ( zs0sn(ji,jj) /MAX( zs0a(ji,jj), epsi16 ) )
+               hicif(ji,jj)  = zindb * ( zs0ice(ji,jj)/MAX( zs0a(ji,jj), epsi16 ) )
+               zindsn        = MAX( rzero, SIGN( rone, hsnif(ji,jj) - epsi06 ) )
+               zindic        = MAX( rzero, SIGN( rone, hicif(ji,jj) - epsi03 ) )
+               zindb         = MAX( zindsn, zindic )
+               zs0a (ji,jj)  = zindb * zs0a(ji,jj)
+               frld (ji,jj)  = 1.0 - zs0a(ji,jj)
+               hsnif(ji,jj)  = zindsn * hsnif(ji,jj)
+               hicif(ji,jj)  = zindic * hicif(ji,jj)
+               zusvosn       = 1.0/MAX( hsnif(ji,jj) * zs0a(ji,jj), epsi16 )
+               zusvoic       = 1.0/MAX( hicif(ji,jj) * zs0a(ji,jj), epsi16 )
+               zignm         = MAX( rzero,  SIGN( rone, hsndif - hsnif(ji,jj) ) )
+               zrtt          = 173.15 * rone 
+               ztsn          =          zignm   * tbif(ji,jj,1)  &
+                              + ( 1.0 - zignm ) * MIN( MAX( zrtt, rt0_snow * zusvosn * zs0c0(ji,jj)) , tfu(ji,jj) ) 
+               ztic1          = MIN( MAX( zrtt, rt0_ice * zusvoic * zs0c1(ji,jj) ) , tfu(ji,jj) )
+               ztic2          = MIN( MAX( zrtt, rt0_ice * zusvoic * zs0c2(ji,jj) ) , tfu(ji,jj) )
+ 
+               tbif(ji,jj,1) = zindsn * ztsn  + ( 1.0 - zindsn ) * tfu(ji,jj)               
+               tbif(ji,jj,2) = zindic * ztic1 + ( 1.0 - zindic ) * tfu(ji,jj)
+               tbif(ji,jj,3) = zindic * ztic2 + ( 1.0 - zindic ) * tfu(ji,jj)
+               qstoif(ji,jj) = zindb  * xlic * zs0st(ji,jj) /  MAX( zs0a(ji,jj), epsi16 )
+
+      END DO 
+
+      vt_i(:,:) = hicif(:,:) * frld(:,:)
+      vt_s(:,:) = hsnif(:,:) * frld(:,:)
+      
+      CALL lbc_lnk( frld,  'T', 1. )                                         ! lateral boundary conditions
+      CALL lbc_lnk( hicif, 'T', 1. )
+      CALL lbc_lnk( hsnif, 'T', 1. )
+      CALL lbc_lnk(  vt_i, 'T', 1. )
+      CALL lbc_lnk(  vt_s, 'T', 1. )
+      !
+#elif defined key_lim3
+
+     ! --------------------
+     ! ice velocity
+     ! --------------------
+     !DO jb = 1, idx%nblen(jgrd)
+     !   ji    = idx%nbi(jb,jgrd)
+     !   jj    = idx%nbj(jb,jgrd)
+     !   u_ice(ji,jj)=0.
+     !   v_ice(ji,jj)=0.
+     !END DO
+     !CALL lbc_lnk(u_ice(:,:),'U', -1. )                                         ! lateral boundary conditions
+     !CALL lbc_lnk(v_ice(:,:),'V', -1. )                                         ! lateral boundary conditions
+
+      DO jl = 1, jpl
+         DO jb = 1, idx%nblen(jgrd)
+            ji    = idx%nbi(jb,jgrd)
+            jj    = idx%nbj(jb,jgrd)
+            zwgt  = idx%nbw(jb,jgrd)
+            zwgt1 = 1.e0 - idx%nbw(jb,jgrd)
+            a_i (ji,jj,jl) = ( a_i (ji,jj,jl) * zwgt1 + dta%a_i (jb,jl) * zwgt ) * tmask(ji,jj,1)  ! Leads fraction 
+            ht_i(ji,jj,jl) = ( ht_i(ji,jj,jl) * zwgt1 + dta%ht_i(jb,jl) * zwgt ) * tmask(ji,jj,1)  ! Ice depth 
+            ht_s(ji,jj,jl) = ( ht_s(ji,jj,jl) * zwgt1 + dta%ht_s(jb,jl) * zwgt ) * tmask(ji,jj,1)  ! Snow depth
+
+            a_i (ji,jj+1,jl) = a_i (ji,jj,jl) * tmask(ji,jj+1,1) ! Leads fraction 
+            ht_i(ji,jj+1,jl) = ht_i(ji,jj,jl) * tmask(ji,jj+1,1) ! Ice depth 
+            ht_s(ji,jj+1,jl) = ht_s(ji,jj,jl) * tmask(ji,jj+1,1) ! Snow depth
+
+            a_i (ji,jj-1,jl) = a_i (ji,jj,jl) * tmask(ji,jj-1,1) ! Leads fraction 
+            ht_i(ji,jj-1,jl) = ht_i(ji,jj,jl) * tmask(ji,jj-1,1) ! Ice depth 
+            ht_s(ji,jj-1,jl) = ht_s(ji,jj,jl) * tmask(ji,jj-1,1) ! Snow depth
+
+            a_i (ji+1,jj,jl) = a_i (ji,jj,jl) * tmask(ji+1,jj,1) ! Leads fraction 
+            ht_i(ji+1,jj,jl) = ht_i(ji,jj,jl) * tmask(ji+1,jj,1) ! Ice depth 
+            ht_s(ji+1,jj,jl) = ht_s(ji,jj,jl) * tmask(ji+1,jj,1) ! Snow depth
+
+            a_i (ji-1,jj,jl) = a_i (ji,jj,jl) * tmask(ji-1,jj,1) ! Leads fraction 
+            ht_i(ji-1,jj,jl) = ht_i(ji,jj,jl) * tmask(ji-1,jj,1) ! Ice depth 
+            ht_s(ji-1,jj,jl) = ht_s(ji,jj,jl) * tmask(ji-1,jj,1) ! Snow depth
+
+            zindaa = ( 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - a_i(ji,jj,jl) ) ) ) * tmask(ji-1:ji+1,jj-1:jj+1,1) ! 0 if no ice
+            ! --------------------
+            ! Ice and snow volumes
+            ! --------------------
+            v_i(ji-1:ji+1,jj-1:jj+1,jl) = ht_i(ji-1:ji+1,jj-1:jj+1,jl) * a_i(ji-1:ji+1,jj-1:jj+1,jl)
+            v_s(ji-1:ji+1,jj-1:jj+1,jl) = ht_s(ji-1:ji+1,jj-1:jj+1,jl) * a_i(ji-1:ji+1,jj-1:jj+1,jl)
+
+            ! -------------
+            ! Ice salinity
+            !---------------
+            sm_i(ji-1:ji+1,jj-1:jj+1,jl)   = zindaa * 8.0  + ( 1.0 - zindaa ) * 0.1
+            smv_i(ji-1:ji+1,jj-1:jj+1,jl)  = MIN( sm_i(ji-1:ji+1,jj-1:jj+1,jl) , sss_m(ji-1:ji+1,jj-1:jj+1) ) * v_i(ji-1:ji+1,jj-1:jj+1,jl)
+            
+            !----------
+            ! Ice age
+            !----------
+            o_i(ji-1:ji+1,jj-1:jj+1,jl)    = zindaa * 1.0   + ( 1.0 - zindaa )
+            oa_i(ji-1:ji+1,jj-1:jj+1,jl)   = o_i(ji-1:ji+1,jj-1:jj+1,jl) * a_i(ji-1:ji+1,jj-1:jj+1,jl)
+            
+            !------------------------------
+            ! Sea ice surface temperature
+            !------------------------------
+            t_su(ji-1:ji+1,jj-1:jj+1,jl)   = zindaa * ( rtt - 1.9 ) + ( 1.0 - zindaa ) * t_bo(ji-1:ji+1,jj-1:jj+1)
+            
+            !------------------------------------
+            ! Snow temperature and heat content
+            !------------------------------------
+            DO jk = 1, nlay_s
+               t_s(ji-1:ji+1,jj-1:jj+1,jk,jl) = zindaa * ( rtt - 1.9 ) + ( 1.0 - zindaa ) * rtt
+               ! Snow energy of melting
+               e_s(ji-1:ji+1,jj-1:jj+1,jk,jl) = zindaa * rhosn * ( cpic * ( rtt - t_s(ji-1:ji+1,jj-1:jj+1,jk,jl) ) + lfus )
+               ! Change dimensions
+               e_s(ji-1:ji+1,jj-1:jj+1,jk,jl) = e_s(ji-1:ji+1,jj-1:jj+1,jk,jl) / unit_fac
+               ! Multiply by volume, so that heat content in 10^9 Joules
+               e_s(ji-1:ji+1,jj-1:jj+1,jk,jl) = e_s(ji-1:ji+1,jj-1:jj+1,jk,jl) * area(ji-1:ji+1,jj-1:jj+1) * &
+                    v_s(ji-1:ji+1,jj-1:jj+1,jl)  / nlay_s
+            END DO !jk
+            
+            !-----------------------------------------------
+            ! Ice salinities, temperature and heat content 
+            !-----------------------------------------------
+            DO jk = 1, nlay_i
+               t_i(ji-1:ji+1,jj-1:jj+1,jk,jl) = zindaa * ( rtt - 1.9 ) + ( 1.0 - zindaa ) * rtt 
+               s_i(ji-1:ji+1,jj-1:jj+1,jk,jl) = zindaa * 8.0 + ( 1.0 - zindaa ) * 0.1
+               ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
+               
+               ! heat content per unit volume
+               e_i(ji-1:ji+1,jj-1:jj+1,jk,jl) = zindaa * rhoic * &
+                    (   cpic    * ( ztmelts - t_i(ji-1:ji+1,jj-1:jj+1,jk,jl) ) &
+                    +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji-1:ji+1,jj-1:jj+1,jk,jl)-rtt),-epsi20) ) &
+                    - rcp      * ( ztmelts - rtt ) &
+                    )
+               
+               ! Correct dimensions to avoid big values
+               e_i(ji-1:ji+1,jj-1:jj+1,jk,jl) = e_i(ji-1:ji+1,jj-1:jj+1,jk,jl) / unit_fac 
+               
+               ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
+               e_i(ji-1:ji+1,jj-1:jj+1,jk,jl) = e_i(ji-1:ji+1,jj-1:jj+1,jk,jl) * & 
+                    area(ji-1:ji+1,jj-1:jj+1) * a_i(ji-1:ji+1,jj-1:jj+1,jl) * ht_i(ji-1:ji+1,jj-1:jj+1,jl) / &
+                    nlay_i
+            END DO ! jk
+
+        END DO !jb
+
+
+         CALL lbc_lnk(  a_i(:,:,jl), 'T', 1. )                                         ! lateral boundary conditions
+         CALL lbc_lnk( ht_i(:,:,jl), 'T', 1. )
+         CALL lbc_lnk( ht_s(:,:,jl), 'T', 1. )
+         CALL lbc_lnk(  v_i(:,:,jl), 'T', 1. )
+         CALL lbc_lnk(  v_s(:,:,jl), 'T', 1. )
+ 
+         CALL lbc_lnk( smv_i(:,:,jl), 'T', 1. )
+         CALL lbc_lnk(  sm_i(:,:,jl), 'T', 1. )
+         CALL lbc_lnk(  oa_i(:,:,jl), 'T', 1. )
+         CALL lbc_lnk(   o_i(:,:,jl), 'T', 1. )
+         CALL lbc_lnk(  t_su(:,:,jl), 'T', 1. )
+         DO jk = 1, nlay_s
+            CALL lbc_lnk(t_s(:,:,jk,jl), 'T', 1. )
+            CALL lbc_lnk(e_s(:,:,jk,jl), 'T', 1. )
+         END DO
+         DO jk = 1, nlay_i
+            CALL lbc_lnk(t_i(:,:,jk,jl), 'T', 1. )
+            CALL lbc_lnk(e_i(:,:,jk,jl), 'T', 1. )
+         END DO
+
+      END DO !jl
+    
+#endif
+      !      
+      !ENDIF !nit000/=0
+      IF( nn_timing == 1 ) CALL timing_stop('bdy_ice_frs')
+      !
+   END SUBROUTINE bdy_ice_frs
+#else
+   !!---------------------------------------------------------------------------------
+   !!   Default option                                                    Empty module
+   !!---------------------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE bdy_ice_lim( kt )      ! Empty routine
+      WRITE(*,*) 'bdy_ice_lim: You should not have seen this print! error?', kt
+   END SUBROUTINE bdy_ice_lim
+#endif
+
+   !!=================================================================================
+END MODULE bdyice_lim
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3938)
@@ -69,8 +69,9 @@
       REAL   , POINTER  ::  flagu, flagv                   !    -   -
       REAL(wp) ::   zefl, zwfl, znfl, zsfl                 ! local scalars
-      INTEGER, DIMENSION (2)                ::   kdimsz
+      INTEGER, DIMENSION (1)                ::   kdimsz
       INTEGER, DIMENSION(jpbgrd,jp_bdy)       ::   nblendta         ! Length of index arrays 
       INTEGER, ALLOCATABLE, DIMENSION(:,:,:)  ::   nbidta, nbjdta   ! Index arrays: i and j indices of bdy dta
       INTEGER, ALLOCATABLE, DIMENSION(:,:,:)  ::   nbrdta           ! Discrete distance from rim points
+      REAL, ALLOCATABLE, DIMENSION(:)         ::   znblendta           
       REAL(wp), DIMENSION(jpidta,jpjdta)    ::   zmask            ! global domain mask
       CHARACTER(LEN=80),DIMENSION(jpbgrd)  ::   clfile
@@ -80,6 +81,6 @@
          &             ln_mask_file, cn_mask_file, nn_dyn2d, nn_dyn2d_dta, &
          &             nn_dyn3d, nn_dyn3d_dta, nn_tra, nn_tra_dta,         &  
-#if defined key_lim2
-         &             nn_ice_lim2, nn_ice_lim2_dta,                       &
+#if ( defined key_lim2 || defined key_lim3 )
+         &             nn_ice_lim, nn_ice_lim_dta,                       &
 #endif
          &             ln_vol, nn_volctl, nn_rimwidth
@@ -121,7 +122,7 @@
       nn_tra(:)         = 0
       nn_tra_dta(:)     = -1  ! uninitialised flag
-#if defined key_lim2
-      nn_ice_lim2(:)    = 0
-      nn_ice_lim2_dta(:)= -1  ! uninitialised flag
+#if ( defined key_lim2 || defined key_lim3 )
+      nn_ice_lim(:)    = 0
+      nn_ice_lim_dta(:)= -1  ! uninitialised flag
 #endif
       ln_vol            = .false.
@@ -204,16 +205,16 @@
         IF(lwp) WRITE(numout,*)
 
-#if defined key_lim2
+#if ( defined key_lim2 || defined key_lim3 )
         IF(lwp) WRITE(numout,*) 'Boundary conditions for sea ice:  '
-        SELECT CASE( nn_ice_lim2(ib_bdy) )                  
+        SELECT CASE( nn_ice_lim(ib_bdy) )                  
           CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
           CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
           CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_tra' )
         END SELECT
-        IF( nn_ice_lim2(ib_bdy) .gt. 0 ) THEN 
-           SELECT CASE( nn_ice_lim2_dta(ib_bdy) )                   ! 
+        IF( nn_ice_lim(ib_bdy) .gt. 0 ) THEN 
+           SELECT CASE( nn_ice_lim_dta(ib_bdy) )                   ! 
               CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for bdy data'        
               CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      boundary data taken from file'
-              CASE DEFAULT   ;   CALL ctl_stop( 'nn_ice_lim2_dta must be 0 or 1' )
+              CASE DEFAULT   ;   CALL ctl_stop( 'nn_ice_lim_dta must be 0 or 1' )
            END SELECT
         ENDIF
@@ -327,7 +328,10 @@
             DO igrd = 1, jpbgrd
                id_dummy = iom_varid( inum, 'nbi'//cgrid(igrd), kdimsz=kdimsz )  
-               nblendta(igrd,ib_bdy) = kdimsz(1)
-               jpbdta = MAX(jpbdta, kdimsz(1))
-            ENDDO
+               !clem nblendta(igrd,ib_bdy) = kdimsz(1)
+               !clem jpbdta = MAX(jpbdta, kdimsz(1))
+               nblendta(igrd,ib_bdy) = MAXVAL(kdimsz)
+               jpbdta = MAX(jpbdta, MAXVAL(kdimsz))
+            ENDDO
+            CALL iom_close( inum )
 
          ENDIF 
@@ -505,21 +509,25 @@
             ENDDO
 
-         ELSE            ! Read global index arrays from boundary coordinates file.
-
-            DO igrd = 1, jpbgrd
-               CALL iom_get( inum, jpdom_unknown, 'nbi'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_bdy),:,1) )
+         ELSE            ! Read global index arrays from boundary coordinates file
+
+          CALL iom_open( cn_coords_file(ib_bdy), inum )
+          DO igrd = 1, jpbgrd
+               ALLOCATE(znblendta(nblendta(igrd,ib_bdy)))
+
+               CALL iom_get( inum, jpdom_unknown, 'nbi'//cgrid(igrd), znblendta(1:nblendta(igrd,ib_bdy)) )
                DO ii = 1,nblendta(igrd,ib_bdy)
-                  nbidta(ii,igrd,ib_bdy) = INT( dta_global(ii,1,1) )
+                  nbidta(ii,igrd,ib_bdy) = INT( znblendta(ii) )
                END DO
-               CALL iom_get( inum, jpdom_unknown, 'nbj'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_bdy),:,1) )
+               CALL iom_get( inum, jpdom_unknown, 'nbj'//cgrid(igrd), znblendta(1:nblendta(igrd,ib_bdy)) )
                DO ii = 1,nblendta(igrd,ib_bdy)
-                  nbjdta(ii,igrd,ib_bdy) = INT( dta_global(ii,1,1) )
+                  nbjdta(ii,igrd,ib_bdy) = INT( znblendta(ii) )
                END DO
-               CALL iom_get( inum, jpdom_unknown, 'nbr'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_bdy),:,1) )
+               CALL iom_get( inum, jpdom_unknown, 'nbr'//cgrid(igrd), znblendta(1:nblendta(igrd,ib_bdy)) )
                DO ii = 1,nblendta(igrd,ib_bdy)
-                  nbrdta(ii,igrd,ib_bdy) = INT( dta_global(ii,1,1) )
+                  nbrdta(ii,igrd,ib_bdy) = INT( znblendta(ii) )
                END DO
 
-               ibr_max = MAXVAL( nbrdta(:,igrd,ib_bdy) )
+               ibr_max = MAXVAL( nbrdta(1:nblendta(igrd,ib_bdy),igrd,ib_bdy) )
+               !WRITE(numout,*) nbrdta(1:nblendta(igrd,ib_bdy),igrd,ib_bdy)
                IF(lwp) WRITE(numout,*)
                IF(lwp) WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
@@ -527,5 +535,5 @@
                IF (ibr_max < nn_rimwidth(ib_bdy))   &
                      CALL ctl_stop( 'nn_rimwidth is larger than maximum rimwidth in file',cn_coords_file(ib_bdy) )
-
+               DEALLOCATE(znblendta)
             END DO
             CALL iom_close( inum )
@@ -680,4 +688,6 @@
       tmask_i (:,:) = tmask(:,:,1) * tmask_i(:,:)             
       bdytmask(:,:) = tmask(:,:,1)
+      bdyumask(:,:) = umask(:,:,1)
+      bdyvmask(:,:) = vmask(:,:,1)
 
       ! bdy masks and bmask are now set to zero on boundary points:
@@ -803,5 +813,4 @@
 
       IF( nn_timing == 1 ) CALL timing_stop('bdy_init')
-
    END SUBROUTINE bdy_init
 
